%% this code read the stimuli and computed the properties of each stimulus such as
% the Area, Edge length, ConvexHull and spatial frequency. The final
% figure show the total values of these stimuli' propery. 

clear all; close all; 

% directory to read iamges
Dir='/Users/hadimaboudi/Projects/BET lab in Sheffield/Projects/concept of Zero/AnalysingStimuli_noiseless patterns/SharedData/Stimuli'
    

for t=1:3 % different shapes
    
    if t==1
    shapeoffigure='C';
    elseif t==2
    shapeoffigure='S';
    else
    shapeoffigure='D';
    end

for m=1:6 % different number
    
    clear lastnumber
    
    if m==1
        lastnumber=1;
    elseif m==2
        lastnumber=5;
    elseif m==6
        lastnumber=5;
    else   
        lastnumber=7;
    end
    
for k=1:lastnumber
    
    [t m k]
   

 
F = fullfile(Dir,[ shapeoffigure num2str(m) '_' num2str(k) '.png']);
    [X,~,~] =  imread(F);
    
%[X,~,~] = imread( [ shapeoffigure num2str(m) '_' num2str(k) '.png']); % reading the image

X=X(:,6:end,:); % exclude the left vertical line in the images

SE2 = strel('diamond',7); % parameter for removing the pixel noise
%X = imclose(rgb2gray(X),SE2); 

% Set the size of image to 350x350
resize=1;
X = imresize(X,resize);
im =im2bw(X,graythresh(X));
dim=min(size(im,1),size(im,2));
dimm=max(size(im,1),size(im,2));

thrisholdpixel=350;

while dimm >thrisholdpixel*resize
    
    if size(im,1)>thrisholdpixel*resize
        im=im(1:thrisholdpixel*resize,:,:);
    end
    
    if size(im,2)>thrisholdpixel*resize
        im=im(:,1:thrisholdpixel*resize,:);
    end
    dimm=max(size(im,1),size(im,2));    
end

while dim <thrisholdpixel*resize
    
    if size(im,1)<thrisholdpixel*resize
        im(dim+1,:,:)=255*ones(1,size(im,2));
    end
    
    if size(im,2)<thrisholdpixel*resize
        im(:,dim+1,:)=255*ones(size(im,1),1);
    end
    dim=min(size(im,1),size(im,2));
    
end

%%%%% Edge length 
Ibw = ~im2bw(X,graythresh(X)); % make binary image
% Ifill = imfill(Ibw,'holes');   % remove holes
% Iarea = bwareaopen(Ifill,10);
% Ifinal = bwlabel(Iarea);
stat = regionprops(Ibw,'Area','MajorAxisLength','MinorAxisLength');

%%%%%%%% convex hull
CH = bwconvhull(Ibw); 
ConxHull(t,m,k)=sum(sum(sum(CH)))*36/(thrisholdpixel^2);

%%%%%%%  total colored area
total_area(t,m,k)=sum([stat.Area])*36/(thrisholdpixel^2);

% %%%%% Edge length
if t==1
Edge_length(t,m,k)=sum(2*sqrt(pi)*sqrt([stat.Area]))*6/thrisholdpixel;
else   
Edge_length(t,m,k)=sum(4*sqrt([stat.Area]))*6/thrisholdpixel;
end

%%%%
%%%%%%%%  Spatial frequency 
imf=fftshift(fft2(im)); % Fourier transform of an image
impf=abs(imf).^2;  % power spectrum
N=size(im,1);
f=-N/2:N/2-1;
Pf=rotavg(impf); %% a rotational average of the power spectrum
f1=0:N/2;
%ARE_SP(t,m,k)=trapz(f1(end-150:end-20),Pf(end-150:end-20));

ARE_SP(t,m,k)=trapz(f1(10:end),Pf(10:end));

figure (100)
loglog(f1(1:end),Pf(1:end))
hold on
% Show the spatial frequency
%Powerspectrum1(:,k)=Pf;
% to display the log power spectrum
% % % % % % % figure(m)
% % % % % % % subplot(3,10,k)
% % % % % % % imshow(im), axis xy 
% % % % % % % 
% % % % % % % subplot(3,10,10+k)
% % % % % % % imagesc(f,f,log10(impf)), axis xy 
% % % % % % % 
% % % % % % % subplot(3,10,20+k)
% % % % % % % loglog(f1,Pf)
%ylim([.1E7 .1E13])c

% if k<5
% figure(2)
% loglog(f1,Pf, 'color',(10-k)*.1*[1 0 0],'LineWidth',2)
% %ylim([.1E6 .1E13])
% hold on
% 
% else 
% figure(2)
% loglog(f1,Pf, 'color',(14-k)*.1*[0 0 1],'LineWidth',2)
% %ylim([.1E6 .1E13])
% hold on  
% end

end

end
end

%%%% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Statistics for the blank stimulus 

F = fullfile(Dir,'0.png');
    [X,~,~] =  imread(F);
    

X=X(3:350, 3:350, :);
Ibw = ~im2bw(X,graythresh(X));
Ifill = imfill(Ibw,'holes');
Iarea = bwareaopen(Ifill,10);
Ifinal = bwlabel(Iarea);
stat_zero = regionprops(Ifinal,'Area');

% convex hull
CH_zero = bwconvhull(Ibw);
ConxHull_zeo=sum(sum(sum(CH_zero)))*36/(thrisholdpixel^2);
total_area_zeo=sum([stat_zero.Area])*36/(thrisholdpixel^2);
Edge_length_zeo=sum(2*sqrt(pi)*sqrt([stat_zero.Area]))*6/thrisholdpixel;

im =im2bw(X,graythresh(X));
imf=fftshift(fft2(im)); % Fourier transform of an image
impf=abs(imf).^2;  % power spectrum
N=size(im,1);
f=-N/2:N/2-1;
Pf=rotavg(impf); %% a rotational average of the power spectrum
f1=0:N/2;
ARE_SP_zero=trapz(f1(end-150:end-20),Pf(end-150:end-20));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figures
%
figure
% Spearman's rank correlation
[Corr_Num_physicalcue]=Corr_Analysis(ARE_SP);
[rho pval] = corr(Corr_Num_physicalcue(1,:)',Corr_Num_physicalcue(2,:)', 'type', 'Spearman');

[mean_sp std_sp]=shapestat(ARE_SP);
subplot(1,4,1)
bar([ARE_SP_zero mean_sp]);
hold on
errorbar([ARE_SP_zero mean_sp],[0 std_sp])
ylabel('Area under curve')
xlabel('# elements')
set(gca,'xTick',[1 2 3 4 5 6 7],'xTickLabel',{'0','1','2','3','4','5','6'})

[mean_ta std_ta]=shapestat(total_area);

[Corr_Num_physicalcue]=Corr_Analysis(total_area);
[rho pval] = corr(Corr_Num_physicalcue(1,:)',Corr_Num_physicalcue(2,:)', 'type', 'Spearman')

subplot(1,4,2)
bar([total_area_zeo mean_ta]);
hold on
errorbar([total_area_zeo mean_ta],[0 std_ta])
ylabel('total area(cm2)')
xlabel('# elements')
set(gca,'xTick',[1 2 3 4 5 6 7],'xTickLabel',{'0','1','2','3','4','5','6'})

[mean_el std_el]=shapestat(Edge_length);

[Corr_Num_physicalcue]=Corr_Analysis(Edge_length);
[rho pval] = corr(Corr_Num_physicalcue(1,:)',Corr_Num_physicalcue(2,:)', 'type', 'Spearman')

subplot(1,4,3)
bar([Edge_length_zeo mean_el]);
hold on
errorbar([Edge_length_zeo mean_el],[0 std_el])
ylabel('Edge length(cm)')
xlabel('# elements')
set(gca,'xTick',[1 2 3 4 5 6 7],'xTickLabel',{'0','1','2','3','4','5','6'})


[mean_ch std_ch]=shapestat(ConxHull);

[Corr_Num_physicalcue]=Corr_Analysis(ConxHull);
[rho pval] = corr(Corr_Num_physicalcue(1,:)',Corr_Num_physicalcue(2,:)', 'type', 'Spearman')


subplot(1,4,4)
bar([ConxHull_zeo mean_ch]);
hold on
errorbar([ConxHull_zeo mean_ch],[0 std_ch])
ylabel('Convexhull(cm2)')
xlabel('# elements')
set(gca,'xTick',[1 2 3 4 5 6 7],'xTickLabel',{'0','1','2','3','4','5','6'})




% make directory to store results
dir_make = './results/'
mkdir(dir_make)
save(strcat(dir_make, 'StatisticalFeatures'));